// -*-C++-*-
/*!
 * @file  com_frm_ctrlSVC_impl.h
 * @brief Service implementation header of com_frm_ctrl.idl
 *
 */

#include "com_frm_ctrlSkel.h"
#include <math.h>
#include <geo_std.h>

#ifndef COM_FRM_CTRLSVC_IMPL_H
#define COM_FRM_CTRLSVC_IMPL_H
 
/*
 * Example class implementing IDL interface ComFrmCtrl
 */
class ComFrmCtrlSVC_impl
 : public virtual POA_ComFrmCtrl,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~ComFrmCtrlSVC_impl();

 public:
   // standard constructor
   ComFrmCtrlSVC_impl();
   virtual ~ComFrmCtrlSVC_impl();

   // attributes and operations
   void set_param(CORBA::Double k_pv, CORBA::Double v_m, CORBA::Double k_pr);

  int calc_vel(FRAME geo_ref, FRAME geo_cur, VECTOR p_vel, VECTOR r_vel);

  double k_gain, v_max, k_pos_rot;
  double settle;
  int state;

};



#endif // COM_FRM_CTRLSVC_IMPL_H


