#!/usr/bin/env python
# -*- Python -*-

import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM
import RTC

# Import Service implementation class
# <rtc-template block="service_impl">
from my_service_impl import *

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
import _GlobalIDL, _GlobalIDL__POA

# </rtc-template>

class Holder :
    pass

holder = Holder()

# This module's spesification
# <rtc-template block="module_spec">
emptyrtc_spec = ["implementation_id", "EmptyRtc", 
		 "type_name",         "EmptyRtc", 
		 "description",       "test rtc-tmplate", 
		 "version",           "1.0", 
		 "vendor",            "Takashi Suehiro, AIST", 
		 "category",          "General", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "10", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 "conf.default.conf0", "0",
		 "conf.default.conf1", "1.0",
		 ""]
# </rtc-template>

class EmptyRtc(OpenRTM.DataFlowComponentBase):
	def __init__(self, manager):
		OpenRTM.DataFlowComponentBase.__init__(self, manager)
		 
	def onInitialize(self):
		return RTC.RTC_OK
	
	#def onFinalize(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onActivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onDeactivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onExecute(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	
#
# you can add Ports and configulations to e_rtc after creating it.
#
def makeInPort(comp, name, data, buf) :
    data_name = "_d_" + name
    setattr(comp, data_name, data)
    port_name = "_" + name + "In"
    setattr(comp, port_name, OpenRTM.InPort(name, data, buf))
    comp.registerInPort(name,  getattr(comp, port_name))

def makeOutPort(comp, name, data, buf) :
    data_name = "_d_" + name
    setattr(comp, data_name, data)
    port_name = "_" + name + "Out"
    setattr(comp, port_name, OpenRTM.OutPort(name, data, buf))
    comp.registerOutPort(name,  getattr(comp, port_name))

def mk_comp_sample(comp) :             # holder.comp contains an e_rtc component

    # Set InPort buffers
#    comp._d_th = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
#    comp._thIn = OpenRTM.InPort("th", comp._d_th, OpenRTM.RingBuffer(8))
#    comp.registerInPort("th",comp._thIn)

    makeInPort(comp, "th", RTC.TimedDoubleSeq(RTC.Time(0,0),[]), OpenRTM.RingBuffer(8))

    # Set OutPort buffers
#    comp._d_frame = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
#    comp._frameOut = OpenRTM.OutPort("frame", comp._d_frame, OpenRTM.RingBuffer(8))
#    comp.registerOutPort("frame",comp._frameOut)		

    makeOutPort(comp, "frame", RTC.TimedDoubleSeq(RTC.Time(0,0),[]), OpenRTM.RingBuffer(8))

    # Set service Port which contains providers
    #  skelton has been already imported from _GlobalIDL ans _GlobalIDL__POA
    comp._provPort = OpenRTM.CorbaPort("prov")
    comp._prov1 = MyService_i()
    comp._provPort.registerProvider("prov1", "MyService", comp._prov1)
    comp.registerPort(comp._provPort)

    # Set service Port whic contains consumers
    #  stub is needed here
    comp._consPort = OpenRTM.CorbaPort("cons")
    comp._cons1 = OpenRTM.CorbaConsumer(interfaceType=_GlobalIDL.YourService)
    comp._consPort.registerConsumer("cons1", "YourService", comp._cons1)		
    comp.registerPort(comp._consPort)

    # initialize of configuration-data.
    # <rtc-template block="init_conf_param">
    # data for configulation is set here and used later
    comp._conf0 = [0]
    comp._conf1 = [1.0]
		
def onInit_sub(comp) :                # onInitialize runs after mk_comp.
    # Bind variables and configuration variable
    comp.bindParameter("conf0", comp._conf0, "0")
    comp.bindParameter("conf1", comp._conf1, "1.0")


def MyModuleInit(manager):
    profile = OpenRTM.Properties(defaults_str=emptyrtc_spec)
    manager.registerFactory(profile,
                            EmptyRtc,
                            OpenRTM.Delete)

    # Create a component
    comp = manager.createComponent("EmptyRtc")
    holder.comp = comp

def main():
	mgr = OpenRTM.Manager.init(len(sys.argv), sys.argv)
        holder.mgr = mgr
        holder.orb = mgr._orb
        holder.naming = mgr._namingManager._names[0].ns._cosnaming
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager(True)
#
#        mk_comp_sample(holder.comp)
#        onInit_sub(holder.comp)
#

if __name__ == "__main__":
	main()

