#!/usr/bin/env python
# -*- Python -*-

import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM
import RTC

# Import Service implementation class
# <rtc-template block="service_impl">
from com_mixer_impl import *

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
import _GlobalIDL, _GlobalIDL__POA

# </rtc-template>

class Holder :
    pass

holder = Holder()

# call back classes
class ExecCartesian(OpenRTM.OnWrite) :
    def __init__(self, comp) :
        self.comp=comp
    def __call__(self, value) :
        if(self.comp.act_flag) :
	    self.comp.cartesian_flag=True
            self.comp.out_buf['cartesian']=value.data
#            if(self.comp.joint_flag) :
#                self.comp.output_data()
#            print "caretesian"
            self.comp.output_data()

class ExecJoint(OpenRTM.OnWrite) :
    def __init__(self, comp) :
        self.comp=comp
    def __call__(self, value) :
        if(self.comp.act_flag) :
	    self.comp.joint_flag=True
#            print "ExecJoint"
            self.comp.out_buf['joint']=value.data
#            if(self.comp.cartesian_flag) :
#                self.comp.output_data()
#            print "joint"
            self.comp.output_data()

# This module's spesification
# <rtc-template block="module_spec">
mixer_spec = ["implementation_id", "mixer", 
		 "type_name",         "mixer", 
		 "description",       "test rtc-tmplate", 
		 "version",           "1.0", 
		 "vendor",            "Takashi Suehiro, AIST", 
		 "category",          "General", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "10", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
                 "conf.default.nsize", "7",
		 ""]
# </rtc-template>

class mixer(OpenRTM.DataFlowComponentBase):
	def __init__(self, manager):
		OpenRTM.DataFlowComponentBase.__init__(self, manager)
          
        def output_data(self) :
            self._d_out.data=[]
            for kk in self.out_buf :
		if kk in self._prov1.weight.keys():
                    tmp=self.out_buf[kk]
                    msize=len(tmp)/(self.nsize+1)
                    for ii in range(msize) :
                        for jj in range(self.nsize+1) :
                            tmp[(self.nsize+1)*ii+jj]*=self._prov1.weight[kk][ii]
                    self._d_out.data = self._d_out.data + tmp
                else :
                    self._d_out.data = self._d_out.data + self.out_buf[kk]
            self._outOut.write()

	def onInitialize(self):
		self.act_flag = False
                self.cartesian_flag = False
                self.joint_flag = False
                self.inports={}
                self.outports={}
                self.services={}
                self.out_buf={}
		return RTC.RTC_OK
	
	#def onFinalize(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onActivated(self, ec_id):
		self.act_flag = True
                self.cartesian_flag = False
                self.joint_flag = False
                self.nsize=self._nsize[0]
		return RTC.RTC_OK
	
	def onDeactivated(self, ec_id):
		self.act_flag = False
                self.cartesian_flag = False
                self.joint_flag = False
                self.out_buf={}
		return RTC.RTC_OK
	
	def onExecute(self, ec_id):
                time.sleep(0.01)
		return RTC.RTC_OK
	
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onError(self, ec_id):
		self.act_flag = False
                self.cartesian_flag = False
                self.joint_flag = False
                self.out_buf={}
		return RTC.RTC_OK
	
	def onReset(self, ec_id):
		self.act_flag = False
                self.cartesian_flag = False
                self.joint_flag = False
                self.out_buf={}
		return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	
#
# you can add Ports and configulations to e_rtc after creating it.
#
def makeInPortCB(comp, name, data, buf,cb) :
    data_name = "_d_" + name
    setattr(comp, data_name, data)
    port_name = "_" + name + "In"
    port = OpenRTM.InPort(name, data, buf)
    port.setOnWrite(cb)
    comp.inports[name]=port
    setattr(comp, port_name, port)
    comp.registerInPort(name,  getattr(comp, port_name))

def makeOutPort(comp, name, data, buf) :
    data_name = "_d_" + name
    setattr(comp, data_name, data)
    port_name = "_" + name + "Out"
    port = OpenRTM.OutPort(name, data, buf)
    comp.outports[name]=port
    setattr(comp, port_name, port)
    comp.registerOutPort(name,  getattr(comp, port_name))

def mk_comp_sample(comp) : 

    # Set InPort buffers

    makeInPortCB(comp, "cartesian",
       RTC.TimedDoubleSeq(RTC.Time(0,0),[]), OpenRTM.RingBuffer(8),
       ExecCartesian(comp))

    makeInPortCB(comp, "joint", RTC.TimedDoubleSeq(RTC.Time(0,0),[]),
       OpenRTM.RingBuffer(8), ExecJoint(comp))

    # Set OutPort buffers

    makeOutPort(comp, "out", RTC.TimedDoubleSeq(RTC.Time(0,0),[]), 
       OpenRTM.RingBuffer(8))

    # Set service Port which contains providers
    #  skelton has been already imported from _GlobalIDL ans _GlobalIDL__POA
    comp._provPort = OpenRTM.CorbaPort("prov")
    comp._prov1 = ComMixer_i(comp)
    comp._provPort.registerProvider("com_mixer", "ComMixer", comp._prov1)
    comp.registerPort(comp._provPort)

    # Set service Port whic contains consumers
    #  stub is needed here
#    comp._consPort = OpenRTM.CorbaPort("cons")
#    comp._cons1 = OpenRTM.CorbaConsumer(interfaceType=_GlobalIDL.YourService)
#    comp._consPort.registerConsumer("cons1", "YourService", comp._cons1)
#    comp.registerPort(comp._consPort)

    # initialize of configuration-data.
    # <rtc-template block="init_conf_param">
    # data for configulation is set here and used later
#    comp._conf0 = [0]
#    comp._conf1 = [1.0]
    comp._nsize=[7]
		
def onInit_sub(comp) :                # onInitialize runs after mk_comp.
    # Bind variables and configuration variable
#    comp.bindParameter("conf0", comp._conf0, "0")
#    comp.bindParameter("conf1", comp._conf1, "1.0")
    comp.bindParameter("nsize",comp._nsize, "7")
    comp.nsize=comp._nsize[0]


def MyModuleInit(manager):
    profile = OpenRTM.Properties(defaults_str=mixer_spec)
    manager.registerFactory(profile,
                            mixer,
                            OpenRTM.Delete)

    # Create a component
    comp = manager.createComponent("mixer")
    holder.comp = comp

def main():
	mgr = OpenRTM.Manager.init(len(sys.argv), sys.argv)
        holder.mgr = mgr
        holder.orb = mgr._orb
        holder.naming = mgr._namingManager._names[0].ns._cosnaming
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager(True)
#
        mk_comp_sample(holder.comp)
        onInit_sub(holder.comp)
#

if __name__ == "__main__":
	main()

