#!/usr/bin/env python

# Python example implementations generated from com_move.idl

import time
import CORBA, PortableServer

# Import the Python stub modules so type definitions are available.

import _GlobalIDL

# Import the Python Skeleton modules so skeleton base classes are available.

import _GlobalIDL__POA


# Implementation of interface ComMv

class ComMv_i (_GlobalIDL__POA.ComMv):

    def __init__(self, mv_rtc):
        # Initialise member variables here
        self.rtc=mv_rtc

    # void move_to(in Frame frm)
    def move_to(self, frm):
      for i in range(3) :
        for j in range(3) :
          self.rtc._d_frame.data[3*i+j]=frm.mat[i][j]
        self.rtc._d_frame.data[9+i]=frm.pos[i]

      self.rtc._frameOut.write()
      time.sleep(0.5)
      state = 0
      while not state :
        if self.rtc._stateIn.isNew() :
           state = self.rtc._stateIn.read().data
           print state
        time.sleep(0.01)

if __name__ == "__main__":
    import sys
    
    # Initialise the ORB
    orb = CORBA.ORB_init(sys.argv)
    
    # As an example, we activate an object in the Root POA
    poa = orb.resolve_initial_references("RootPOA")

    # Create an instance of a servant class
    servant = ComMv_i()

    # Activate it in the Root POA
    poa.activate_object(servant)

    # Get the object reference to the object
    objref = servant._this()
    
    # Print a stringified IOR for it
    print orb.object_to_string(objref)

    # Activate the Root POA's manager
    poa._get_the_POAManager().activate()

    # Run the ORB, blocking this thread
    orb.run()

