#!/usr/bin/env python
# -*- Python -*-

MyRtcDir=".."
#from set_env import *
import sys
import time
sys.path.append(".")

save_path = sys.path[:]
sys.path.append(MyRtcDir+'/tools/v_robot')
from v_pa10 import *
sys.path = save_path

# Import RTM module
import OpenRTM
import RTC

# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="global_idl">

# </rtc-template>
class DrawPa10(OpenRTM.OnWrite) :
    def __init__(self, comp) :
        self.comp=comp
    def __call__(self, value) :
        if(self.comp.act_flag) :
            th=value.data
            link1.set_joint(th[0])
            link2.set_joint(th[1])
            link3.set_joint(th[2])
            link4.set_joint(th[3])
            link5.set_joint(th[4])
            link6.set_joint(th[5])
            link7.set_joint(th[6])

# This module's spesification
# <rtc-template block="module_spec">
pa10disp_spec = ["implementation_id", "pa10disp", 
		 "type_name",         "pa10disp", 
		 "description",       "visual model of PA10", 
		 "version",           "1.0", 
		 "vendor",            "Takashi Suehiro, AIST", 
		 "category",          "7dof_arm", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "10", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]

# </rtc-template>

class pa10disp(OpenRTM.DataFlowComponentBase):
	def __init__(self, manager):
		OpenRTM.DataFlowComponentBase.__init__(self, manager)

		# DataPorts initialization
		# <rtc-template block="data_ports">
		self._d_th = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		self._thIn = OpenRTM.InPort("th", self._d_th, OpenRTM.RingBuffer(8))
                self.d_pa10=DrawPa10(self)
                self._thIn.setOnWrite(self.d_pa10)
		self.registerInPort("th",self._thIn)

		# </rtc-template>

		# DataPorts initialization
		# <rtc-template block="service_ports">

		# </rtc-template>


		# initialize of configuration-data.
		# <rtc-template block="configurations">

		# </rtc-template>

		 
	def onInitialize(self):
		# Bind variables and configuration variable
		# <rtc-template block="bind_config">
		# </rtc-template>
                visual.rate(10)
		self.act_flag = False
		return RTC.RTC_OK


	#def onFinalize(self):
	#	return RTC.RTC_OK

	#def onStartup(self, ec_id):
	#	return RTC.RTC_OK

	#def onShutdown(self, ec_id):
	#	return RTC.RTC_OK

        def onActivated(self, ec_id):
            self.act_flag = True
            return RTC.RTC_OK

	def onDeactivated(self, ec_id):
	    self.act_flag = False
	    return RTC.RTC_OK

	#def onExecute(self, ec_id):
        #    if self._thIn.isNew() :
        #        th=self._thIn.read().data
        #        link1.set_joint(th[0])
        #        link2.set_joint(th[1])
        #        link3.set_joint(th[2])
        #        link4.set_joint(th[3])
        #        link5.set_joint(th[4])
        #        link6.set_joint(th[5])
        #        link7.set_joint(th[6])
        #    time.sleep(0.01)
        #    return RTC.RTC_OK

	#def onAborting(self, ec_id):
	#	return RTC.RTC_OK

	def onError(self, ec_id):
	    self.act_flag = False
	    return RTC.RTC_OK

	def onReset(self, ec_id):
	    self.act_flag = False
	    return RTC.RTC_OK

	#def onStateUpdate(self, ec_id):
	#	return RTC.RTC_OK

	#def onRateChanged(self, ec_id):
	#	return RTC.RTC_OK




def MyModuleInit(manager):
    profile = OpenRTM.Properties(defaults_str=pa10disp_spec)
    manager.registerFactory(profile,
                            pa10disp,
                            OpenRTM.Delete)

    # Create a component
    comp = manager.createComponent("pa10disp")



def main():
	mgr = OpenRTM.Manager.init(len(sys.argv), sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()


