/*!
 * @file fk.h
 * @brief forward kinema for pa10
 *
 * @date 2003.11.3
 *
 * Copyright 2003 Takashi Suehiro
 */
// #include <stdio.h>
#include <geo_std.h>

#define LB 315.0
#define LS 450.0
#define LE 500.0
#define LW 80.0
typedef REAL Jacob[6][7];
/*!
 * @class FK
 * @brief class for forward kinema for pa10
 *
 */
class FK
{
 public:
  //! 
  FK();
  ~FK();
  //! 
  int set_tool(FRAME * frm);
  //! 
  int calc_fk(REAL * th);
  //! 
  int link_frame(int idx, FRAME * frm);
  //! 
  int jacob(Jacob jcb);
  //! 
 private:
  //! 
  MATRIX link_mat[8];
  VECTOR link_pos[8];
  VECTOR joint_vec[7];
  VECTOR joint_arm[7];
  //!
  VECTOR ua,fa,fr,ef;
  //! 
  MATRIX a_mat[8];
  //! 
  VECTOR v_tool;
};

