#!/usr/bin/env python

from Tkinter import *

class SliderMulti(Frame):
        def mouseDown(self, event) :
                print self.get()
        def mouseDrag(self, event) :
                print self.get()
        def mouseRelease(self, event) :
                print self.get()
        def set_callbacks(self,f1,f2,f3) :
            for chan in self.channels :
                Widget.bind(chan,"<1>",f1)                
                Widget.bind(chan,"<B1-Motion>",f2)
                Widget.bind(chan,"<ButtonRelease-1>",f3)
        def set_cb_down(self,func) :
            for chan in self.channels :
                Widget.bind(chan,"<1>",func)                
        def set_cb_drag(self,func) :
            for chan in self.channels :
                Widget.bind(chan,"<B1-Motion>",func)
        def set_cb_release(self,func) :
            for chan in self.channels :
                Widget.bind(chan,"<ButtonRelease-1>",func)
	def __init__(self, channels, master=None):
		Frame.__init__(self, master)
		self.create_channels(channels)
		self.pack()
 	def create_channels(self, channels):
                print channels
		self.chan_list = channels
                self.channels=[]
		for chan in self.chan_list:
                    tmp=Scale(self, label=chan[0],to=chan[1],orient=VERTICAL)
                    tmp["from"]=chan[2]
                    tmp["resolution"]=chan[3]
                    tmp["length"]=chan[4]
                    tmp.pack(side=LEFT)
                    self.channels.append(tmp)
                    Widget.bind(tmp,"<1>",self.mouseDown)
                    Widget.bind(tmp,"<B1-Motion>",self.mouseDrag)
                    Widget.bind(tmp,"<ButtonRelease-1>",self.mouseDrag)
	def get(self):
		val = []
		for s in self.channels:
			val.append(s.get())
		return val

	def set(self, value):
            map(lambda x,y:y.set(x),value,self.channels)

def test ():
	channels = (("angle", 0, 360, 0.1, 200), ("velocity", -100, 100, 0.1, 200))
	return SliderMulti(channels)
